<template>
  <div>
    <b-modal v-model="showModal" id="modal-center" hide-footer title="Logout">
      <div>
        <b-form>
          <b-form>

            <div class="text-center">
              <label class="mb-0">Please, waiting, the system is doing the logout</label>
            </div>

            <div class="text-center">
              <b-spinner variant="primary" label="Text Centered" style="width: 5rem; height: 5rem;"></b-spinner>
            </div>
          </b-form>
          <b-form-text v-if="isErrorSubmitted">
              <span style="color: red">
                {{ typeOfErrorSubmitted }}
              </span>
          </b-form-text>
        </b-form>
      </div>
    </b-modal>
  </div>
</template>

<script>
import Vuex from 'vuex';

import Store from '../../stores/Store';

export default {
  name: 'Logout',
  store: Store,
  data() {
    return {
      isErrorSubmitted: false,
      showModal: false,
      typeOfErrorSubmitted: ''
    }
  },
  methods: {
    ...Vuex.mapMutations([
      'setUserByStoreAsLogout'
    ]),
    ...Vuex.mapGetters([
      'getUserByStore'
    ]),
    onSubmit() {
      this.isSubmitting = true;
      this.isErrorSubmitted = false;
      this.$http.post('resource/logout-user').then(
          () => {
            this.showModal = false;
            this.setUserByStoreAsLogout();
            this.$swal.fire({
              title: 'Success!',
              text: 'The sign out is completed!',
              icon: 'success',
              confirmButtonText: 'Cool'
            }).then(() => {
            });
          },
          (event) => {
            this.isErrorSubmitted = true;
            this.$swal.fire({
              title: 'Error!',
              text: 'Uhm, there is an error, please re-do',
              icon: 'error',
              confirmButtonText: 'Cool'
            });
            switch (event.status) {
              case (500): {
                this.typeOfErrorSubmitted = 'Uhm, there is an error, please re-do';
                break;
              }
              default: {
                this.typeOfErrorSubmitted = 'Uhm, there is an error';
              }
            }
          }).then(() => {
        this.isSubmitting = false;
      });
    },
    showModalAction() {
      if (this.getUserByStore().isEditing) {
        this.$swal.fire({
          title: 'Maybe you are editing some things, are you sure to do the logout?',
          showDenyButton: true,
          showCancelButton: true,
          confirmButtonText: 'Yes',
          denyButtonText: `No, I wish to continue to remain logged`,
        }).then((result) => {
          if (result.isConfirmed) {
            this.showModal = true;
            this.isErrorSubmitted = false;
            this.onSubmit();
          }
        })
      } else {
        this.showModal = true;
        this.isErrorSubmitted = false;
        this.onSubmit();
      }

    }
  }
}
</script>
